"""Subpackage."""

from typing import TYPE_CHECKING as __tc

if __tc:
    from mastapy._private.bearings._1936 import BearingCatalog
    from mastapy._private.bearings._1937 import BasicDynamicLoadRatingCalculationMethod
    from mastapy._private.bearings._1938 import BasicStaticLoadRatingCalculationMethod
    from mastapy._private.bearings._1939 import BearingCageMaterial
    from mastapy._private.bearings._1940 import BearingDampingMatrixOption
    from mastapy._private.bearings._1941 import BearingLoadCaseResultsForPST
    from mastapy._private.bearings._1942 import BearingLoadCaseResultsLightweight
    from mastapy._private.bearings._1943 import BearingMeasurementType
    from mastapy._private.bearings._1944 import BearingModel
    from mastapy._private.bearings._1945 import BearingRow
    from mastapy._private.bearings._1946 import BearingSettings
    from mastapy._private.bearings._1947 import BearingSettingsDatabase
    from mastapy._private.bearings._1948 import BearingSettingsItem
    from mastapy._private.bearings._1949 import BearingStiffnessMatrixOption
    from mastapy._private.bearings._1950 import (
        ExponentAndReductionFactorsInISO16281Calculation,
    )
    from mastapy._private.bearings._1951 import FluidFilmTemperatureOptions
    from mastapy._private.bearings._1952 import HybridSteelAll
    from mastapy._private.bearings._1953 import JournalBearingType
    from mastapy._private.bearings._1954 import JournalOilFeedType
    from mastapy._private.bearings._1955 import MountingPointSurfaceFinishes
    from mastapy._private.bearings._1956 import OuterRingMounting
    from mastapy._private.bearings._1957 import RatingLife
    from mastapy._private.bearings._1958 import RollerBearingProfileTypes
    from mastapy._private.bearings._1959 import RollingBearingArrangement
    from mastapy._private.bearings._1960 import RollingBearingDatabase
    from mastapy._private.bearings._1961 import RollingBearingKey
    from mastapy._private.bearings._1962 import RollingBearingRaceType
    from mastapy._private.bearings._1963 import RollingBearingType
    from mastapy._private.bearings._1964 import RotationalDirections
    from mastapy._private.bearings._1965 import SealLocation
    from mastapy._private.bearings._1966 import SKFSettings
    from mastapy._private.bearings._1967 import TiltingPadTypes
else:
    import sys as __sys

    from lazy_imports import LazyImporter as __LazyImporter

    __import_structure = {
        "_private.bearings._1936": ["BearingCatalog"],
        "_private.bearings._1937": ["BasicDynamicLoadRatingCalculationMethod"],
        "_private.bearings._1938": ["BasicStaticLoadRatingCalculationMethod"],
        "_private.bearings._1939": ["BearingCageMaterial"],
        "_private.bearings._1940": ["BearingDampingMatrixOption"],
        "_private.bearings._1941": ["BearingLoadCaseResultsForPST"],
        "_private.bearings._1942": ["BearingLoadCaseResultsLightweight"],
        "_private.bearings._1943": ["BearingMeasurementType"],
        "_private.bearings._1944": ["BearingModel"],
        "_private.bearings._1945": ["BearingRow"],
        "_private.bearings._1946": ["BearingSettings"],
        "_private.bearings._1947": ["BearingSettingsDatabase"],
        "_private.bearings._1948": ["BearingSettingsItem"],
        "_private.bearings._1949": ["BearingStiffnessMatrixOption"],
        "_private.bearings._1950": ["ExponentAndReductionFactorsInISO16281Calculation"],
        "_private.bearings._1951": ["FluidFilmTemperatureOptions"],
        "_private.bearings._1952": ["HybridSteelAll"],
        "_private.bearings._1953": ["JournalBearingType"],
        "_private.bearings._1954": ["JournalOilFeedType"],
        "_private.bearings._1955": ["MountingPointSurfaceFinishes"],
        "_private.bearings._1956": ["OuterRingMounting"],
        "_private.bearings._1957": ["RatingLife"],
        "_private.bearings._1958": ["RollerBearingProfileTypes"],
        "_private.bearings._1959": ["RollingBearingArrangement"],
        "_private.bearings._1960": ["RollingBearingDatabase"],
        "_private.bearings._1961": ["RollingBearingKey"],
        "_private.bearings._1962": ["RollingBearingRaceType"],
        "_private.bearings._1963": ["RollingBearingType"],
        "_private.bearings._1964": ["RotationalDirections"],
        "_private.bearings._1965": ["SealLocation"],
        "_private.bearings._1966": ["SKFSettings"],
        "_private.bearings._1967": ["TiltingPadTypes"],
    }

    __sys.modules[__name__] = __LazyImporter(
        "mastapy",
        globals()["__file__"],
        __import_structure,
    )

__all__ = (
    "BearingCatalog",
    "BasicDynamicLoadRatingCalculationMethod",
    "BasicStaticLoadRatingCalculationMethod",
    "BearingCageMaterial",
    "BearingDampingMatrixOption",
    "BearingLoadCaseResultsForPST",
    "BearingLoadCaseResultsLightweight",
    "BearingMeasurementType",
    "BearingModel",
    "BearingRow",
    "BearingSettings",
    "BearingSettingsDatabase",
    "BearingSettingsItem",
    "BearingStiffnessMatrixOption",
    "ExponentAndReductionFactorsInISO16281Calculation",
    "FluidFilmTemperatureOptions",
    "HybridSteelAll",
    "JournalBearingType",
    "JournalOilFeedType",
    "MountingPointSurfaceFinishes",
    "OuterRingMounting",
    "RatingLife",
    "RollerBearingProfileTypes",
    "RollingBearingArrangement",
    "RollingBearingDatabase",
    "RollingBearingKey",
    "RollingBearingRaceType",
    "RollingBearingType",
    "RotationalDirections",
    "SealLocation",
    "SKFSettings",
    "TiltingPadTypes",
)
